## REPRESENTATION CIRCULAIRE D'UN GRAPHE
## P. Cubaud <cubaud@cnam.fr>

## definition de l'image
size(800,800)
background(250)

## generation de la topologie du graphe
N = 100
P = 0.008
pred = [[0]*N for i in range(N)]
for i in range(N):
    for j in range(N):
       if random(0,1)< P :
          pred[i][j] = 1
    pred[i][i] = 0
           
## dessin des sommets
xc = width/2
yc = height/2
r = 0.9*xc
fill(0)
a = 0
for i in range(N):
    # dessin du sommet i
    x = xc+r*cos(a)
    y = yc-r*sin(a)
    ellipse(x,y,4,4)
    #text(str(i),x,y)
    a += 2*PI/N

## dessin des arcs
tota = 0
strokeWeight(1)
stroke(0,30)
for i in range(N):
    a =2*PI*i/N
    xi = xc+r*cos(a)
    yi = yc-r*sin(a)
    for j in range(N):
        if pred[i][j] == 1:
            a = 2*PI*j/N
            xj = xc+r*cos(a)
            yj = yc-r*sin(a)
            line(xi,yi,xj,yj)
            tota += 1

## sauvegarde du resultat
save("circ-"+str(N)+"-"+str(tota)+".png")