## PC juil20+nov20+jan21
## graphe des echanges entre personnages des Miserables de Victor Hugo
## les donnees d'origine de Knuth sont sur https: ##people.sc.fsu.edu/~jburkardt/datasets/sgb/sgb.html
## voir aussi https: ##vega.github.io/editor/#/examples/vega/arc-diagram

## chargement des donnees
sommets = loadTable("sommets.csv","header") 
N = sommets.getRowCount()   
arcs = loadTable("arcs.csv","header") 

## dessiner le fond
size(1000,500) 
background(255) 

## dessiner l'axe central
xaxe = 10 
largeurAxe = width - 2*xaxe 
yaxe = height-80 
##stroke(0) strokeWeight(3) 
##line(xaxe,yaxe,width-xaxe,yaxe) 

## dessiner tous les arcs 
noFill() 
stroke(0,50) 
strokeCap(SQUARE) 
for r in arcs.rows() :
   source = r.getInt(0)   ##r.getInt("Source") 
   target = r.getInt(1)   ##r.getInt("Target") 
   weight = r.getInt(2)   ##r.getInt("Weight") 
   epaisseur = map(weight,1,50,1,50) 
   strokeWeight(epaisseur) 
   xdepart = xaxe + largeurAxe * source/(N-1) 
   xarrivee = xaxe + largeurAxe * target/(N-1) 
   rayon = abs(xarrivee-xdepart) 
   xcentre = (xarrivee+xdepart)/2 
   arc(xcentre, yaxe, rayon, rayon, PI, 2*PI) 

## afficher les noms des personnages sous l'axe central
fill(0) 
for r in sommets.rows() :
  ident = r.getInt(0)   ##r.getInt("Id") 
  nom = r.getString(1)  ##r.getInt("Label") 
  x = xaxe + largeurAxe * ident/(N-1) 
  ellipse(x,yaxe,3,3) 
  pushMatrix() 
  translate(x,yaxe + 5)
  rotate(PI/2) 
  text(nom,0,0) 
  popMatrix() 

save("miserables.png") 